Foreman - Bug #14924

taxonomies/edit.html.erb takes minutes to render
05/04/2016 05:46 AM - Taylan Develioglu

Status: Closed
Priority: Normal
Assignee: Tomer Brisker
Category: Organizations and Locations
Target version: 1.12.0
Difficulty: Fixed in Releases:
Triaged: Found in Releases: 1.11.1
Bugzilla link: 1396642 Red Hat JIRA:
Pull request: https://github.com/theforeman/foreman/p
ull/3491
Description

Trying to open the edit page of either a location or organization takes multiple minutes.
The time is spent rendering taxonomies/edit.html.erb and the passenger process stays ~100% utilization throughout the request.

Log attached is from rails environment set to “development’, notice that it takes over 6 minutes to complete the request.

Related issues:
Related to Foreman - Bug #10893: Editing organizations/locations hangs in 1.8.2 Resolved 06/22/2015
Has duplicate Foreman - Bug #10138: Manage Location and Organization unusable... Duplicate 04/14/2015

Associated revisions

Revision 956055dc - 05/06/2016 08:58 AM - Tomer Brisker

Fixes #14924 - Improve performance of taxonomy edit page

Non standard ids were not cached in TaxHost.

This led to multiple repeat queries in the database each time any of the
*_ids" function were being called.

Used templated were calculated by going over all hosts in the taxonomy
and trying to lookup the provisioning template for each one, we now look
for all templates that match any combination of os, hostgroup and
environment for the taxonomy's hosts.

Hosts in Taxhost did not include the :interface table, leading to n+1
queries for delegated attributes such as subnets and proxies.

History

#1 - 05/04/2016 05:47 AM - Dominic Cleal
- Related to Bug #10893: Editing organizations/locations hangs in 1.8.2 added

#2 - 05/04/2016 05:48 AM - Dominic Cleal

Could be the same as #10893 and related issues, but enabling SQL logging may show for sure (
http://theforeman.org/manuals/1.11/index.html#7.2Debugging).

#3 - 05/04/2016 06:13 AM - Taylan Develioglu

- File taxonomies_edit_render_w_sql.log.gz added

Attached logfile with SQL logging enabled.

It shows a huge amount of this repeating:

2016-05-04 12:01:04 [sql] [D] CACHE (0.0ms) SELECT "templates".* FROM "templates" INNER JOIN "operatingsystems_provisioning_templates"
ON "operatingsystems_provisioning_templates"."provisioning_template_id" = "templates"."id" INNER JOIN "operatingsystems" ON
"operatingsystems"."id" = "operatingsystems_provisioning_templates"."operatingsystem_id" INNER JOIN "template_kinds" ON "template_kinds"."id" =
"templates"."template_kind_id" INNER JOIN "template_combinations" ON "template_combinations"."provisioning_template_id" = "templates"."id"

WHERE "templates"."type" IN ('ProvisioningTemplate') AND "operatingsystems"."id" = 1 AND "template_kinds"."name" = 'provision' AND
"template_combinations"."hostgroup_id" IS NULL AND "template_combinations"."environment_id" = 1 ORDER BY templates.name LIMIT 1
#4 - 05/04/2016 07:15 AM - Tomer Brisker
- Status changed from New to Assigned

- Assignee set to Tomer Brisker

#5 - 05/04/2016 08:07 AM - The Foreman Bot
- Status changed from Assigned to Ready For Testing
- Pull request https://github.com/theforeman/foreman/pull/3491 added

#6 - 05/04/2016 08:22 AM - Taylan Develioglu
- File pull_3491_result.log.gz added

| see a significant improvement with PR 3491 active. Wallclock went down from ~6 minutes to ~1 minute. Kudos!.
| do still notice a lot of repeat sql queries being done, however (see attached log).

#7 - 05/04/2016 10:54 AM - Taylan Develioglu

The final PR reduced wallclock time to ~20s! \o/

#8 - 05/06/2016 09:02 AM - Anonymous
- Status changed from Ready For Testing to Closed
- % Done changed from 0 to 100

Applied in changeset 956055dca1284c80069cd0ff884a7960b53e1143.

#9 - 05/06/2016 09:16 AM - Marek Hulan

- translation missing: en.field_release set to 136

#10 - 11/30/2016 05:09 AM - Ohad Levy
- Bugzilla link set to 1396642

#11 - 12/13/2016 03:23 AM - Tomer Brisker

- Has duplicate Bug #10138: Manage Location and Organization unusable once thousands of nodes are assigned added

#12 - 12/13/2016 10:01 AM - Daniel Lobato Garcia

- Target version set to 1.4.3

Files

taxonomies_edit_render.log 30.8 KB 05/04/2016 Taylan Develioglu

taxonomies_edit_render_w_sql.log.gz 2.58 MB 05/04/2016 Taylan Develioglu

pull_3491_result.log.gz 119 KB 05/04/2016 Taylan Develioglu
